unit FldigiTalk;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, AgentObjects_TLB, ScktComp, StrUtils,ShellAPI, ExtCtrls, ComCtrls,
  Menus;

const
  WM_NOTIFYICON  = WM_USER+333;

type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    Label1: TLabel;
    Memo1: TMemo;
    Agent1: TAgent;
    Edit2: TEdit;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeakWord();
    procedure SpeakNumber();
    procedure LookForNumber();
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);



    private
    { Private declarations }
    public
    { Public declarations }
        TrayIcon: TNotifyIconData;
    HMainIcon: HICON;
    procedure ClickTrayIcon(var msg: TMessage); message WM_NOTIFYICON;
    Procedure MinimizeClick(Sender:TObject);
   // number: boolean;

  end;

var
  Form1: TForm1;
  invisible:IAgentCtlCharacter;
implementation

 //uses U_CloseDlg;
{$R *.dfm}

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);

  var
  character:string;
begin
 character := socket.ReceiveText;
 if character = '?' then character := ' ';
 if character = '!' then character := ' ';
 if character = '.' then character := ' ';
 if character = ':' then character := ' ';
 if character = ',' then character := ' ';

 Memo1.Text := (Memo1.Text + character);
 Memo1.Text := UpperCase(Memo1.text);
 if length(memo1.text) >1 then
        begin
        if LastDelimiter(' ', Memo1.text) = length(memo1.text) then LookForNumber;
        end;
 end;

 procedure Tform1.LookForNumber();

 var
 i:integer;
 begin

for i := 1 to length(memo1.text) do
if memo1.text[i] = '1' then
begin
speaknumber;
memo1.Clear;
exit;
end;
for i := 1 to length(memo1.text) do
if memo1.text[i] = '2' then
begin
speaknumber;
memo1.Clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '3' then
begin
speaknumber;
memo1.clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '4' then
begin
speaknumber;
memo1.clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '5' then
begin
speaknumber;
memo1.Clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '6' then
begin
speaknumber;
memo1.clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '7' then
begin
speaknumber;
memo1.Clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '8' then
begin
speaknumber;
memo1.clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '9' then
begin
speaknumber;
memo1.clear;
exit;
end;

for i := 1 to length(memo1.text) do
if memo1.text[i] = '0' then
begin
speaknumber;
memo1.clear;
exit;
end;

begin
speakword;
exit;
end;
end;

procedure Tform1.SpeakWord();
 begin
 if Trim(memo1.text) = 'DE' then Memo1.text := ' D,E ';
 if Trim(memo1.text) = 'PSE' then Memo1.text := ' please ';
 if Trim(memo1.text) = 'BTU' then Memo1.text := ' back, to, you ';
 if Trim(memo1.text) = 'QSO' then Memo1.text := ' Q,S,O ';
 if Trim(memo1.text) = 'QRP' then Memo1.text := ' Q,R,P ';
 if Trim(memo1.text) = 'QRM' then Memo1.text := ' Q,R,M ';
 if Trim(memo1.text) = 'QRN' then Memo1.text := ' Q,R,N ';
 if Trim(memo1.text) = 'QRT' then Memo1.text := ' Q,R,T ';
 if Trim(memo1.text) = 'QRZ' then Memo1.text := ' Q,R,Z ';
 if Trim(memo1.text) = 'QRO' then Memo1.text := ' Q,R,O ';
 if Trim(memo1.text) = 'QSY' then Memo1.text := ' Q,S,Y ';
 if Trim(memo1.text) = 'QSB' then Memo1.text := ' Q,S,B ';
 if Trim(memo1.text) = 'QSL' then Memo1.text := ' Q,S,L ';
 if Trim(memo1.text) = 'QTH' then Memo1.text := ' Q,T,H ';
 if Trim(memo1.text) = 'QRT' then Memo1.text := ' Q,R,T ';
 if Trim(memo1.text) = 'QST' then Memo1.text := ' Q,S,T ';
 if Trim(memo1.text) = 'SK' then Memo1.text := ' S,K ';
 if Trim(memo1.text) = 'OM' then Memo1.text := ' O,M ';
 if Trim(memo1.text) = 'DX' then Memo1.text := ' D,X ';
 if Trim(memo1.text) = 'ALC' then Memo1.text := ' A,L,C ';
 if Trim(memo1.text) = 'TNK' then Memo1.text := ' T,N,X ';
 if Trim(memo1.text) = 'CPY' then Memo1.text := ' COPY ';
 if Trim(memo1.text) = 'USA' then Memo1.text := ' U,S,A ';
 if Trim(memo1.text) = 'PEP' then Memo1.text := ' P,E,P ';
 if Trim(memo1.text) = 'QST' then Memo1.text := ' Q,S,T ';
 if Trim(memo1.text) = 'HR' then Memo1.text := ' HERE ';
 if Trim(memo1.text) = 'CUL' then Memo1.text := ' SEE YOU LATER ';
 if Trim(memo1.text) = 'AGN' then Memo1.text := ' AGAIN ';
 if Trim(memo1.text) = 'UR' then Memo1.text := ' YOUR ';
 if Trim(memo1.text) = 'ABT' then Memo1.text := ' ABOUT ';
 if Trim(memo1.text) = 'TNX' then Memo1.text := ' THANKS ';
 if Trim(memo1.text) = 'FB' then Memo1.text := ' FINE BUSINESS ';
 if Trim(memo1.text) = 'CW' then Memo1.text := ' C,W ';
 if Trim(memo1.text) = 'ARRL' then Memo1.text := ' A,R,R,L ';
 if Trim(memo1.text) = 'A' then Memo1.text := ' AY ';


 invisible.Show(false);
 invisible.speak(memo1.text, '');
 memo1.clear;
 exit;
 end;


  Procedure Tform1.SpeakNumber();

  var
ss, ss2:string;
n:integer;
begin
ss := memo1.text;

for n:= 1 to length(ss) do
begin
ss2 := ss2 + ss[n] + ',';
edit2.text := ss2;
end;
invisible.Show(false);
invisible.speak(ss2, '');
end;



procedure TForm1.FormActivate(Sender: TObject);

begin
    Shell_NotifyIcon(NIM_ADD, @TrayIcon);
     {hide the taskbar button}
     if IsWindowVisible(Application.Handle)
     then ShowWindow(Application.Handle, SW_HIDE);

//end;

//begin
Serversocket1.Active:=true;
Agent1.characters.load('invisible','invisible.acs');
invisible:=Agent1.Characters.Character('invisible');
Agent1.Connected:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Serversocket1.Active:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  HMainIcon:=LoadIcon(MainInstance, 'MAINICON');

  Shell_NotifyIcon(NIM_DELETE, @TrayIcon);
  with trayIcon do
  begin
    cbSize              := sizeof(TNotifyIconData);
    Wnd                 := handle;
    uID                 := 123;
    uFlags              := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    uCallbackMessage    := WM_NOTIFYICON;
    hIcon               := HMainIcon;
    szTip               := 'Click to restore';
  end;
  Application.OnMinimize:= MinimizeClick;
end;
{**************** MinimizeClick ************}
Procedure TForm1.MinimizeClick(Sender:TObject);
begin
Shell_NotifyIcon(NIM_Add, @TrayIcon);
   hide;
   {hide the taskbar button}
   if IsWindowVisible(Application.Handle)
   then ShowWindow(Application.Handle, SW_HIDE);
end;
procedure TForm1.ClickTrayIcon(var msg: TMessage);
begin
  case msg.lparam of
    WM_LBUTTONUP, WM_LBUTTONDBLCLK :
    {WM_BUTTONDOWN may cause next Icon to activate if this icon is deleted -
        (Icons shift left and left neighbor will be under mouse at ButtonUp time)}
    begin
      Application.Restore;  {restore the application}
      If WindowState = wsMinimized then WindowState := wsNormal;  {Reset minimized state}
      visible:=true;
      SetForegroundWindow(Application.Handle); {Force form to the foreground }
      Shell_NotifyIcon(NIM_Delete, @TrayIcon);
    end;
  end;
end;
{************* FormDestroy **************}
procedure TForm1.FormDestroy(Sender: TObject);
{Ensure that systray icon is removed at end - no matter what}
begin
  Shell_NotifyIcon(NIM_Delete, @TrayIcon)
end;






end.

